Index: src/unittests/Makefile.am
===================================================================
--- src/unittests/Makefile.am	(revision 9a71862bde9003acbdd76381bcea1012b54a0ed6)
+++ src/unittests/Makefile.am	(revision 8725ed38a099a2b4b3d95307d79ba0bdb7474c3f)
@@ -4,5 +4,5 @@
 AM_CXXFLAGS = $(CPPUNIT_CFLAGS)
 
-TESTS = ActOnAllUnitTest AnalysisBondsUnitTests AnalysisCorrelationToPointUnitTest AnalysisCorrelationToSurfaceUnitTest AnalysisPairCorrelationUnitTest BondGraphUnitTest ListOfBondsUnitTest LogUnitTest MemoryUsageObserverUnitTest MemoryAllocatorUnitTest StackClassUnitTest VectorUnitTest
+TESTS = ActOnAllUnitTest AnalysisBondsUnitTests AnalysisCorrelationToPointUnitTest AnalysisCorrelationToSurfaceUnitTest AnalysisPairCorrelationUnitTest BondGraphUnitTest InfoUnitTest ListOfBondsUnitTest LogUnitTest MemoryUsageObserverUnitTest MemoryAllocatorUnitTest StackClassUnitTest VectorUnitTest
 check_PROGRAMS = $(TESTS)
 noinst_PROGRAMS = $(TESTS)
@@ -25,4 +25,7 @@
 BondGraphUnitTest_SOURCES = bondgraphunittest.cpp bondgraphunittest.hpp
 BondGraphUnitTest_LDADD = ../libmolecuilder.a
+
+InfoUnitTest_SOURCES = infounittest.cpp infounittest.hpp
+InfoUnitTest_LDADD = ../libmolecuilder.a
 
 ListOfBondsUnitTest_SOURCES = listofbondsunittest.cpp listofbondsunittest.hpp
Index: src/unittests/infounittest.cpp
===================================================================
--- src/unittests/infounittest.cpp	(revision 8725ed38a099a2b4b3d95307d79ba0bdb7474c3f)
+++ src/unittests/infounittest.cpp	(revision 8725ed38a099a2b4b3d95307d79ba0bdb7474c3f)
@@ -0,0 +1,66 @@
+/*
+ * InfoUnitTest.cpp
+ *
+ *  Created on: Nov 25, 2009
+ *      Author: heber
+ */
+
+using namespace std;
+
+#include <cppunit/CompilerOutputter.h>
+#include <cppunit/extensions/TestFactoryRegistry.h>
+#include <cppunit/ui/text/TestRunner.h>
+
+#include <iostream>
+#include <stdio.h>
+
+#include "info.hpp"
+#include "infounittest.hpp"
+
+/********************************************** Test classes **************************************/
+
+// Registers the fixture into the 'registry'
+CPPUNIT_TEST_SUITE_REGISTRATION( InfoTest );
+
+
+void InfoTest::setUp()
+{
+};
+
+
+void InfoTest::tearDown()
+{
+};
+
+/** UnitTest for FunctionTest().
+ */
+void InfoTest::FunctionTest()
+{
+  const char *msg = __func__;
+  class Info test(msg);
+
+  CPPUNIT_ASSERT_EQUAL( msg , test.FunctionName );
+  CPPUNIT_ASSERT_EQUAL( 1, test.verbosity );
+};
+
+
+/********************************************** Main routine **************************************/
+
+int main(int argc, char **argv)
+{
+  // Get the top level suite from the registry
+  CppUnit::Test *suite = CppUnit::TestFactoryRegistry::getRegistry().makeTest();
+
+  // Adds the test to the list of test to run
+  CppUnit::TextUi::TestRunner runner;
+  runner.addTest( suite );
+
+  // Change the default outputter to a compiler error format outputter
+  runner.setOutputter( new CppUnit::CompilerOutputter( &runner.result(),
+                                                       std::cerr ) );
+  // Run the tests.
+  bool wasSucessful = runner.run();
+
+  // Return error code 1 if the one of test failed.
+  return wasSucessful ? 0 : 1;
+};
Index: src/unittests/infounittest.hpp
===================================================================
--- src/unittests/infounittest.hpp	(revision 8725ed38a099a2b4b3d95307d79ba0bdb7474c3f)
+++ src/unittests/infounittest.hpp	(revision 8725ed38a099a2b4b3d95307d79ba0bdb7474c3f)
@@ -0,0 +1,32 @@
+/*
+ * InfoUnitTest.hpp
+ *
+ *  Created on: Nov 25, 2009
+ *      Author: heber
+ */
+
+#ifndef INFOUNITTEST_HPP_
+#define INFOUNITTEST_HPP_
+
+#include <cppunit/extensions/HelperMacros.h>
+
+class info;
+
+/********************************************** Test classes **************************************/
+
+class InfoTest : public CppUnit::TestFixture
+{
+    CPPUNIT_TEST_SUITE( InfoTest) ;
+    CPPUNIT_TEST ( FunctionTest );
+    CPPUNIT_TEST_SUITE_END();
+
+public:
+      void setUp();
+      void tearDown();
+      void FunctionTest();
+
+private:
+
+};
+
+#endif /* INFOUNITTEST_HPP_ */