Index: src/UIElements/Qt4/QtDialog.cpp
===================================================================
--- src/UIElements/Qt4/QtDialog.cpp	(revision 838cd09f5b0b8fc58fc121f2fad94ab4a811175b)
+++ src/UIElements/Qt4/QtDialog.cpp	(revision 12948c2ccfa9172ddcc2b58e9905c238b969ea5d)
@@ -115,4 +115,9 @@
 }
 
+void QtDialog::queryUnsignedInts(const char *title,string)
+{
+  registerQuery(new UnsignedIntsQtQuery(title,inputLayout,this));
+}
+
 void QtDialog::queryDouble(const char* title,string)
 {
Index: src/UIElements/Qt4/QtDialog.hpp
===================================================================
--- src/UIElements/Qt4/QtDialog.hpp	(revision 838cd09f5b0b8fc58fc121f2fad94ab4a811175b)
+++ src/UIElements/Qt4/QtDialog.hpp	(revision 12948c2ccfa9172ddcc2b58e9905c238b969ea5d)
@@ -37,4 +37,5 @@
   virtual void queryInts(const char *,std::string = "");
   virtual void queryUnsignedInt(const char *,std::string = "");
+  virtual void queryUnsignedInts(const char *,std::string = "");
   virtual void queryDouble(const char*,std::string = "");
   virtual void queryDoubles(const char*,std::string = "");
@@ -75,4 +76,5 @@
   class StringsQtQuery;
   class UnsignedIntQtQuery;
+  class UnsignedIntsQtQuery;
   class VectorQtQuery;
   class VectorsQtQuery;
Index: src/UIElements/Qt4/Query/QtQuery.hpp
===================================================================
--- src/UIElements/Qt4/Query/QtQuery.hpp	(revision 838cd09f5b0b8fc58fc121f2fad94ab4a811175b)
+++ src/UIElements/Qt4/Query/QtQuery.hpp	(revision 12948c2ccfa9172ddcc2b58e9905c238b969ea5d)
@@ -48,4 +48,5 @@
 class StringsQtQueryPipe;
 class UnsignedIntQtQueryPipe;
+class UnsignedIntsQtQueryPipe;
 class VectorQtQueryPipe;
 class VectorsQtQueryPipe;
@@ -294,4 +295,22 @@
 };
 
+class QtDialog::UnsignedIntsQtQuery : public Dialog::UnsignedIntsQuery {
+public:
+  UnsignedIntsQtQuery(std::string _title,QBoxLayout *_parent,QtDialog *_dialog);
+  virtual ~UnsignedIntsQtQuery();
+  virtual bool handle();
+  void IntegerEntered(const QString&);
+  void IntegerSelected();
+  void AddInteger();
+  void RemoveInteger();
+private:
+  QBoxLayout *parent;
+  QBoxLayout *thisLayout;
+  QLabel *titleLabel;
+
+  QtQueryListPipe<unsigned int> *pipe;
+};
+
+
 class QtDialog::VectorQtQuery : public Dialog::VectorQuery {
 public:
Index: src/UIElements/Qt4/Query/UnsignedIntsQtQuery.cpp
===================================================================
--- src/UIElements/Qt4/Query/UnsignedIntsQtQuery.cpp	(revision 12948c2ccfa9172ddcc2b58e9905c238b969ea5d)
+++ src/UIElements/Qt4/Query/UnsignedIntsQtQuery.cpp	(revision 12948c2ccfa9172ddcc2b58e9905c238b969ea5d)
@@ -0,0 +1,78 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * UnsignedIntsQtQuery.cpp
+ *
+ *  Created on: Oct 25, 2010
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include <Qt/qboxlayout.h>
+#include <Qt/qlabel.h>
+#include <Qt/qlineedit.h>
+#include <Qt/qlistwidget.h>
+#include <Qt/qpushbutton.h>
+
+#include "CodePatterns/MemDebug.hpp"
+
+#include "UIElements/Qt4/Query/QtQuery.hpp"
+#include "UIElements/Qt4/Pipe/QtQueryListPipe.hpp"
+
+
+QtDialog::UnsignedIntsQtQuery::UnsignedIntsQtQuery(string _title,QBoxLayout *_parent,QtDialog *_dialog) :
+    Dialog::UnsignedIntsQuery(_title),
+    parent(_parent)
+{
+  QHBoxLayout * thisHLayout = new QHBoxLayout();
+  QVBoxLayout * thisV1Layout = new QVBoxLayout();
+  QVBoxLayout * thisV2Layout = new QVBoxLayout();
+
+  QLabel *titleLabel = new QLabel(QString(getTitle().c_str()));
+  QLabel *inputLabel = new QLabel("Enter to add");
+  QListWidget* inputList = new QListWidget();
+  inputList->setSelectionMode(QAbstractItemView::ExtendedSelection);
+  QLineEdit* inputBox = new QLineEdit();
+  inputLabel->setBuddy(inputBox);
+  titleLabel->setBuddy(inputList);
+  QPushButton* AddButton = new QPushButton("Add");
+  AddButton->setEnabled(false);
+  QPushButton* RemoveButton = new QPushButton("Remove");
+  RemoveButton->setEnabled(false);
+
+  thisV1Layout->addWidget(titleLabel);
+  thisV1Layout->addWidget(inputList);
+  thisV2Layout->addWidget(inputLabel);
+  thisV2Layout->addWidget(inputBox);
+  thisV2Layout->addWidget(AddButton);
+  thisV2Layout->addWidget(RemoveButton);
+  parent->addLayout(thisHLayout);
+  thisHLayout->addLayout(thisV1Layout);
+  thisHLayout->addLayout(thisV2Layout);
+
+  pipe = new QtQueryListPipe<unsigned int>(&tmp,_dialog,inputBox,inputList,AddButton,RemoveButton);
+  connect(inputBox,SIGNAL(textChanged(const QString&)),pipe,SLOT(IntegerEntered(const QString&)));
+  connect(inputList,SIGNAL(itemSelectionChanged()),pipe,SLOT(IntegerSelected()));
+  connect(AddButton,SIGNAL(Clicked()),pipe,SLOT(AddValue()));
+  connect(RemoveButton,SIGNAL(Clicked()),pipe,SLOT(RemoveRow()));
+}
+
+QtDialog::UnsignedIntsQtQuery::~UnsignedIntsQtQuery()
+{
+  delete pipe;
+}
+
+bool QtDialog::UnsignedIntsQtQuery::handle() {
+  return true;
+}
+
+