Index: tests/regression/Domain/AddEmptyBoundary/testsuite-domain-add-empty-boundary.at
===================================================================
--- tests/regression/Domain/AddEmptyBoundary/testsuite-domain-add-empty-boundary.at	(revision 8a957e8b6a87527326d7123e0d60c7848a69a814)
+++ tests/regression/Domain/AddEmptyBoundary/testsuite-domain-add-empty-boundary.at	(revision 13799e61558eed972ef8a0528faff8bbe010609e)
@@ -5,4 +5,5 @@
 AT_CHECK([/bin/cp -f ${abs_top_srcdir}/${AUTOTEST_PATH}/Domain/AddEmptyBoundary/pre/test.conf .], 0)
 AT_CHECK([../../molecuilder -i test.conf  -c "5, 10, 15"], 0, [stdout], [stderr])
+AT_CHECK([fgrep "Box domain is now" stdout], 0, [ignore], [ignore])
 AT_CHECK([diff test.conf ${abs_top_srcdir}/${AUTOTEST_PATH}/Domain/AddEmptyBoundary/post/test.conf], 0, [stdout], [stderr])
 AT_CLEANUP
Index: tests/regression/Domain/CenterInBox/testsuite-domain-center-in-box.at
===================================================================
--- tests/regression/Domain/CenterInBox/testsuite-domain-center-in-box.at	(revision 8a957e8b6a87527326d7123e0d60c7848a69a814)
+++ tests/regression/Domain/CenterInBox/testsuite-domain-center-in-box.at	(revision 13799e61558eed972ef8a0528faff8bbe010609e)
@@ -5,4 +5,5 @@
 AT_CHECK([/bin/cp -f ${abs_top_srcdir}/${AUTOTEST_PATH}/Domain/CenterInBox/pre/test.conf .], 0)
 AT_CHECK([../../molecuilder -i test.conf  -b "15, 0, 15, 0, 0, 15"], 0, [stdout], [stderr])
+AT_CHECK([fgrep "Box domain is now" stdout], 0, [ignore], [ignore])
 AT_CHECK([diff test.conf ${abs_top_srcdir}/${AUTOTEST_PATH}/Domain/CenterInBox/post/test.conf], 0, [stdout], [stderr])
 AT_CLEANUP
Index: tests/regression/Domain/CenterOnEdge/testsuite-domain-center-on-edge.at
===================================================================
--- tests/regression/Domain/CenterOnEdge/testsuite-domain-center-on-edge.at	(revision 8a957e8b6a87527326d7123e0d60c7848a69a814)
+++ tests/regression/Domain/CenterOnEdge/testsuite-domain-center-on-edge.at	(revision 13799e61558eed972ef8a0528faff8bbe010609e)
@@ -5,4 +5,5 @@
 AT_CHECK([/bin/cp -f ${abs_top_srcdir}/${AUTOTEST_PATH}/Domain/CenterOnEdge/pre/test.conf .], 0)
 AT_CHECK([../../molecuilder -i test.conf  -O], 0, [stdout], [stderr])
+AT_CHECK([fgrep "Box domain is now" stdout], 0, [ignore], [ignore])
 AT_CHECK([diff test.conf ${abs_top_srcdir}/${AUTOTEST_PATH}/Domain/CenterOnEdge/post/test.conf], 0, [stdout], [stderr])
 AT_CLEANUP
Index: tests/regression/Domain/ChangeBox/testsuite-domain-change-box.at
===================================================================
--- tests/regression/Domain/ChangeBox/testsuite-domain-change-box.at	(revision 8a957e8b6a87527326d7123e0d60c7848a69a814)
+++ tests/regression/Domain/ChangeBox/testsuite-domain-change-box.at	(revision 13799e61558eed972ef8a0528faff8bbe010609e)
@@ -4,5 +4,6 @@
 AT_KEYWORDS([domain])
 AT_CHECK([../../molecuilder -i test.conf  -o pcp -B "10, 0, 10, 0, 0, 10"], 0, [stdout], [stderr])
-AT_CHECK([fgrep "BoxLength" test.conf], 0, [stdout], [stderr])
+AT_CHECK([fgrep "Box domain is now" stdout], 0, [ignore], [ignore])
+AT_CHECK([fgrep "BoxLength" test.conf], 0, [ignore], [ignore])
 AT_CHECK([diff test.conf ${abs_top_srcdir}/${AUTOTEST_PATH}/Domain/ChangeBox/post/test.conf], 0, [stdout], [stderr])
 AT_CLEANUP
Index: tests/regression/Domain/RepeatBox/testsuite-domain-repeat-box.at
===================================================================
--- tests/regression/Domain/RepeatBox/testsuite-domain-repeat-box.at	(revision 8a957e8b6a87527326d7123e0d60c7848a69a814)
+++ tests/regression/Domain/RepeatBox/testsuite-domain-repeat-box.at	(revision 13799e61558eed972ef8a0528faff8bbe010609e)
@@ -5,4 +5,5 @@
 AT_CHECK([/bin/cp -f ${abs_top_srcdir}/${AUTOTEST_PATH}/Domain/RepeatBox/pre/test.conf .], 0)
 AT_CHECK([../../molecuilder -i test.conf  -o xyz -d "1, 1, 1"], 0, [stdout], [stderr])
+AT_CHECK([fgrep "Box domain is now" stdout], 0, [ignore], [ignore])
 AT_CHECK([file=test.xyz;sort -n $file | grep -v "Created by" >$file-sorted], 0, [ignore], [ignore])
 AT_CHECK([file=test.xyz;sort -n ${abs_top_srcdir}/${AUTOTEST_PATH}/Domain/RepeatBox/post/$file  | grep -v "Created by" >$file-sorted2], 0, [ignore], [ignore])
@@ -10,4 +11,5 @@
 AT_CHECK([/bin/cp -f ${abs_top_srcdir}/${AUTOTEST_PATH}/Domain/RepeatBox/pre/test.conf test-x.conf], 0)
 AT_CHECK([../../molecuilder -i test-x.conf  -o xyz -d "2, 1, 1"], 0, [stdout], [stderr])
+AT_CHECK([fgrep "Box domain is now" stdout], 0, [ignore], [ignore])
 AT_CHECK([file=test-x.xyz;sort -n $file | grep -v "Created by" >$file-sorted], 0, [ignore], [ignore])
 AT_CHECK([file=test-x.xyz;sort -n ${abs_top_srcdir}/${AUTOTEST_PATH}/Domain/RepeatBox/post/$file  | grep -v "Created by" >$file-sorted2], 0, [ignore], [ignore])
@@ -15,4 +17,5 @@
 AT_CHECK([/bin/cp -f ${abs_top_srcdir}/${AUTOTEST_PATH}/Domain/RepeatBox/pre/test.conf test-y.conf], 0)
 AT_CHECK([../../molecuilder -i test-y.conf  -o xyz -d "1, 2, 1"], 0, [stdout], [stderr])
+AT_CHECK([fgrep "Box domain is now" stdout], 0, [ignore], [ignore])
 AT_CHECK([file=test-y.xyz;sort -n $file | grep -v "Created by" >$file-sorted], 0, [ignore], [ignore])
 AT_CHECK([file=test-y.xyz;sort -n ${abs_top_srcdir}/${AUTOTEST_PATH}/Domain/RepeatBox/post/$file  | grep -v "Created by" >$file-sorted2], 0, [ignore], [ignore])
@@ -20,4 +23,5 @@
 AT_CHECK([/bin/cp -f ${abs_top_srcdir}/${AUTOTEST_PATH}/Domain/RepeatBox/pre/test.conf test-z.conf], 0)
 AT_CHECK([../../molecuilder -i test-z.conf  -o xyz -d "1, 1, 2"], 0, [stdout], [stderr])
+AT_CHECK([fgrep "Box domain is now" stdout], 0, [ignore], [ignore])
 AT_CHECK([file=test-z.xyz;sort -n $file | grep -v "Created by" >$file-sorted], 0, [ignore], [ignore])
 AT_CHECK([file=test-z.xyz;sort -n ${abs_top_srcdir}/${AUTOTEST_PATH}/Domain/RepeatBox/post/$file  | grep -v "Created by" >$file-sorted2], 0, [ignore], [ignore])
Index: tests/regression/Domain/ScaleBox/testsuite-domain-scale-box.at
===================================================================
--- tests/regression/Domain/ScaleBox/testsuite-domain-scale-box.at	(revision 8a957e8b6a87527326d7123e0d60c7848a69a814)
+++ tests/regression/Domain/ScaleBox/testsuite-domain-scale-box.at	(revision 13799e61558eed972ef8a0528faff8bbe010609e)
@@ -5,4 +5,5 @@
 AT_CHECK([/bin/cp -f ${abs_top_srcdir}/${AUTOTEST_PATH}/Domain/ScaleBox/pre/test.conf .], 0)
 AT_CHECK([../../molecuilder -i test.conf  --scale-box "0.5, 1., 0.9"], 0, [stdout], [stderr])
+AT_CHECK([fgrep "Box domain is now" stdout], 0, [ignore], [ignore])
 AT_CHECK([diff test.conf ${abs_top_srcdir}/${AUTOTEST_PATH}/Domain/ScaleBox/post/test.conf], 0, [stdout], [stderr])
 AT_CLEANUP