Index: src/CommandLineParser.hpp
===================================================================
--- src/CommandLineParser.hpp	(revision 7e6b008345766c6fe1944b6cb57c2847aa592191)
+++ src/CommandLineParser.hpp	(revision 13892b0f345f9589fbbc5c03efa50305466eea2c)
@@ -17,4 +17,74 @@
 #include <list>
 
+/** This class is a wrapper for boost::program_options.
+ *
+ * <h1> CommandLine Howto </h1>
+ * <h2> Introduction </h2>
+ *
+ * The UIFactory is a base class for the User Interaction. There are three UI specializations:
+ * Text, GUI and CommandLine. Accessing functionality via the CommandLine UI is explained here.
+ *
+ * First, an Action has to be written for the specific functionality. This Action should
+ * be added in Actions/...Action in the respective subdirectory of the following types:
+ *  -# Analysis: Analysis actions like evaluating pair correlation, bonds, ...
+ *  -# Atom: adding, removing, manipulating atoms
+ *  -# Cmd: specifying data bases, verbosity, ...
+ *  -# Fragmentation: fragmenting a system, performing graph analysis, ...
+ *  -# Molecule: adding, removing, manipulating molecules
+ *  -# Parser: Parsing files (loading, saving)
+ *  -# Tesselation: obtaining (non)convex surface of a molecule, embedding, ...
+ *  -# World: Setting Box dimensions, default name of new molecules, ...
+ *
+ *  The CommandLineUIFactory is a specialization of the UIFactory for parsing command
+ *  line parameters, generating and executing actions there from.
+ *
+ *  The idea of the CommandLineFactory is explained elsewhere, here we would like to give a
+ *  receipe for creating new actions.
+ *
+ * <h3>Introducing new actions</h3>
+ *
+ * Let us now introduce what to do if a new action is to be implemented. Here, we use the
+ * CommandLineVersionAction as an example.
+ * This consists if basically three parts:
+ * 1. Create the files, write the classes and make them compilable
+ *   - Create new source and header files in one of the above subfolders in the Actions folder,
+ *     e.g. create VersionAction.cpp and VersionAction.hpp in Actions/Cmd/
+ *   - Give it a sensible class name, the convention is <type><what it does>Action,
+ *     where <type> is basically the naming (written out) of the subdirectory,
+ *     e.g. class CommandLineVersionAction.
+ *   - Add the source and header file to the respective variables in molecuilder/src/Makefile.am,
+ *     e.g. if you add a Cmd action the variables are CMDACTIONSOURCE and CMDACTIONHEADER,
+ *     such that they get compiled.
+ * 2. Add an instance to the CommandLineUIFactory, such that they are known to the UI.
+ *   - Add the header file as an include to UIElements/CommandLineWindow.cpp, e.g.
+ *     #include "Actions/Cmd/VersionAction.hpp"
+ *   - Add an instance of your class to the specific populater-function in
+ *     UIElements/CommandLineWindow.cpp, e.g. for the above Cmd action, add to populateCmdActions()
+ *     add new CommandLineVersionAction().
+ *     This will automatically register in the ActionRegistry.
+ * 3. Give them an option name, short hand an description, such that they can be referenced from
+ *    the command line.
+ *   - think of a new key name, e.g. "version", which is the long form of the command parameter,
+ *     i.e. --version).
+ *   - add this key to every map of MapofActions, i.e. to
+ *     - MapofActions::DescriptionMap: the description which appears as help and tooltip
+ *     - MapofActions::ShortFormMap: the short form of the command parameter (e.g. -v)
+ *     - MapofActions::ValueMap: the value the command parameter has (do not create if it does not need one)
+ *   - If your action requires additional parameters, these need to be added in the same manner as in
+ *     the list item above.
+ *
+ *  Don't forget to write the actual code. :)
+ *
+ * <h3>Writing an action</h3>
+ *
+ *  As you write a new action you may think in terms of the command line, i.e. you want to use this
+ *  new functionality you add by calling molecuilder as: ./molecuilder --super-action foobar.txt, where
+ *  the key of your new action would be "super-action". While this is fine, keep in mind, that your action
+ *  should be useable for the other UI specializations as well, i.e. from the menu and the GUI. Therefore,
+ *  -# Don't use cin to ask the user for input: Use Query...()!
+ *  -# Rather don't use cout/cerrs, but either give Log() or eLog() or use QueryEmpty() if you want to give
+ *     the user specific information what you ask of him.
+ *
+ */
 class CommandLineParser : public Singleton<CommandLineParser> {
   friend class Singleton<CommandLineParser>;